Xerces-C++: HandlerBase Class Reference

- Main Page
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# HandlerBase Class Reference

Default base class for handlers. More...

Inheritance diagram for HandlerBase:

List of all members.

## Public Member Functions
| HandlerBase ()
virtual | ~HandlerBase ()
Default handlers for the DocumentHandler interface
virtual void | characters (const XMLCh *const chars, const XMLSize_t length)
| Receive notification of character data inside an element.
virtual void | endDocument ()
| Receive notification of the end of the document.
virtual void | endElement (const XMLCh *const name)
| Receive notification of the end of an element.
virtual void | ignorableWhitespace (const XMLCh *const chars, const XMLSize_t length)
| Receive notification of ignorable whitespace in element content.
virtual void | processingInstruction (const XMLCh *const target, const XMLCh *const data)
| Receive notification of a processing instruction.
virtual void | resetDocument ()
| Reset the Docuemnt object on its reuse.
Default implementation of DocumentHandler interface
virtual void | setDocumentLocator (const Locator *const locator)
| Receive a Locator object for document events.
virtual void | startDocument ()
| Receive notification of the beginning of the document.
virtual void | startElement (const XMLCh *const name, AttributeList &attributes)
| Receive notification of the start of an element.
Default implementation of the EntityResolver interface.
virtual InputSource * | resolveEntity (const XMLCh *const publicId, const XMLCh *const systemId)
| Resolve an external entity.
Default implementation of the ErrorHandler interface
virtual void | error (const SAXParseException &exc)
| Receive notification of a recoverable parser error.
virtual void | fatalError (const SAXParseException &exc)
| Report a fatal XML parsing error.
virtual void | warning (const SAXParseException &exc)
| Receive notification of a parser warning.
virtual void | resetErrors ()
| Reset the Error handler object on its reuse.
Default implementation of DTDHandler interface.
virtual void | notationDecl (const XMLCh *const name, const XMLCh *const publicId, const XMLCh *const systemId)
| Receive notification of a notation declaration.
virtual void | resetDocType ()
| Reset the DTD object on its reuse.
virtual void | unparsedEntityDecl (const XMLCh *const name, const XMLCh *const publicId, const XMLCh *const systemId, const XMLCh *const notationName)
| Receive notification of an unparsed entity declaration.

## Detailed Description

Default base class for handlers.

This class implements the default behaviour for four SAX interfaces: EntityResolver, DTDHandler, DocumentHandler, and ErrorHandler.

Application writers can extend this class when they need to implement only part of an interface; parser writers can instantiate this class to provide default handlers when the application has not supplied its own.

Note that the use of this class is optional.

See also:
  EntityResolver::EntityResolver

  DTDHandler::DTDHandler

  DocumentHandler::DocumentHandler

  ErrorHandler::ErrorHandler

## Constructor & Destructor Documentation

HandlerBase::HandlerBase | ( |  | ) |

virtual HandlerBase::~HandlerBase | ( |  | ) | `[virtual]`

## Member Function Documentation

void HandlerBase::characters | ( | const XMLCh *const | chars,
|  | const XMLSize_t | length |
| ) |  |  | `[virtual]`

Receive notification of character data inside an element.

By default, do nothing. Application writers may override this method to take specific actions for each chunk of character data (such as adding the data to a node or buffer, or printing it to a file).

Parameters:

  | chars | The characters.
  | length | The number of characters to use from the character array.

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.

See also:
  DocumentHandler::characters

Implements DocumentHandler.

void HandlerBase::endDocument | ( |  | ) | `[virtual]`

Receive notification of the end of the document.

By default, do nothing. Application writers may override this method in a subclass to take specific actions at the beginning of a document (such as finalising a tree or closing an output file).

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.

See also:
  DocumentHandler::endDocument

Implements DocumentHandler.

void HandlerBase::endElement | ( | const XMLCh *const | name | ) | `[virtual]`

Receive notification of the end of an element.

By default, do nothing. Application writers may override this method in a subclass to take specific actions at the end of each element (such as finalising a tree node or writing output to a file).

Parameters:

  | name | The element type name.

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.

See also:
  DocumentHandler::endElement

Implements DocumentHandler.

void HandlerBase::ignorableWhitespace | ( | const XMLCh *const | chars,
|  | const XMLSize_t | length |
| ) |  |  | `[virtual]`

Receive notification of ignorable whitespace in element content.

By default, do nothing. Application writers may override this method to take specific actions for each chunk of ignorable whitespace (such as adding data to a node or buffer, or printing it to a file).

Parameters:

  | chars | The whitespace characters.
  | length | The number of characters to use from the character array.

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.

See also:
  DocumentHandler::ignorableWhitespace

Implements DocumentHandler.

void HandlerBase::processingInstruction | ( | const XMLCh *const | target,
|  | const XMLCh *const | data |
| ) |  |  | `[virtual]`

Receive notification of a processing instruction.

By default, do nothing. Application writers may override this method in a subclass to take specific actions for each processing instruction, such as setting status variables or invoking other methods.

Parameters:

  | target | The processing instruction target.
  | data | The processing instruction data, or null if none is supplied.

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.

See also:
  DocumentHandler::processingInstruction

Implements DocumentHandler.

void HandlerBase::resetDocument | ( |  | ) | `[virtual]`

Reset the Docuemnt object on its reuse.

See also:
  DocumentHandler::resetDocument

Implements DocumentHandler.

void HandlerBase::setDocumentLocator | ( | const Locator *const | locator | ) | `[virtual]`

Receive a Locator object for document events.

By default, do nothing. Application writers may override this method in a subclass if they wish to store the locator for use with other document events.

Parameters:

  | locator | A locator for all SAX document events.

See also:
  DocumentHandler::setDocumentLocator

  Locator

Implements DocumentHandler.

void HandlerBase::startDocument | ( |  | ) | `[virtual]`

Receive notification of the beginning of the document.

By default, do nothing. Application writers may override this method in a subclass to take specific actions at the beginning of a document (such as allocating the root node of a tree or creating an output file).

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.

See also:
  DocumentHandler::startDocument

Implements DocumentHandler.

void HandlerBase::startElement | ( | const XMLCh *const | name,
|  | AttributeList & | attributes |
| ) |  |  | `[virtual]`

Receive notification of the start of an element.

By default, do nothing. Application writers may override this method in a subclass to take specific actions at the start of each element (such as allocating a new tree node or writing output to a file).

Parameters:

  | name | The element type name.
  | attributes | The specified or defaulted attributes.

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.

See also:
  DocumentHandler::startElement

Implements DocumentHandler.

InputSource * HandlerBase::resolveEntity | ( | const XMLCh *const | publicId,
|  | const XMLCh *const | systemId |
| ) |  |  | `[virtual]`

Resolve an external entity.

Always return null, so that the parser will use the system identifier provided in the XML document. This method implements the SAX default behaviour: application writers can override it in a subclass to do special translations such as catalog lookups or URI redirection.

Parameters:

  | publicId | The public identifer, or null if none is available.
  | systemId | The system identifier provided in the XML document.

Returns:
  The new input source, or null to require the default behaviour. The returned InputSource is owned by the parser which is responsible to clean up the memory.

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.

See also:
  EntityResolver::resolveEntity

Implements EntityResolver.

void HandlerBase::error | ( | const SAXParseException & | exc | ) | `[virtual]`

Receive notification of a recoverable parser error.

The default implementation does nothing. Application writers may override this method in a subclass to take specific actions for each error, such as inserting the message in a log file or printing it to the console.

Parameters:

  | exc | The warning information encoded as an exception.

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.

See also:
  ErrorHandler::warning

  SAXParseException::SAXParseException

Implements ErrorHandler.

void HandlerBase::fatalError | ( | const SAXParseException & | exc | ) | `[virtual]`

Report a fatal XML parsing error.

The default implementation throws a SAXParseException. Application writers may override this method in a subclass if they need to take specific actions for each fatal error (such as collecting all of the errors into a single report): in any case, the application must stop all regular processing when this method is invoked, since the document is no longer reliable, and the parser may no longer report parsing events.

Parameters:

  | exc | The error information encoded as an exception.

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.

See also:
  ErrorHandler::fatalError

  SAXParseException::SAXParseException

Implements ErrorHandler.

void HandlerBase::warning | ( | const SAXParseException & | exc | ) | `[virtual]`

Receive notification of a parser warning.

The default implementation does nothing. Application writers may override this method in a subclass to take specific actions for each warning, such as inserting the message in a log file or printing it to the console.

Parameters:

  | exc | The warning information encoded as an exception.

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.

See also:
  ErrorHandler::warning

  SAXParseException::SAXParseException

Implements ErrorHandler.

void HandlerBase::resetErrors | ( |  | ) | `[virtual]`

Reset the Error handler object on its reuse.

See also:
  ErrorHandler::resetErrors

Implements ErrorHandler.

void HandlerBase::notationDecl | ( | const XMLCh *const | name,
|  | const XMLCh *const | publicId,
|  | const XMLCh *const | systemId |
| ) |  |  | `[virtual]`

Receive notification of a notation declaration.

By default, do nothing. Application writers may override this method in a subclass if they wish to keep track of the notations declared in a document.

Parameters:

  | name | The notation name.
  | publicId | The notation public identifier, or null if not available.
  | systemId | The notation system identifier.

See also:
  DTDHandler::notationDecl

Implements DTDHandler.

void HandlerBase::resetDocType | ( |  | ) | `[virtual]`

Reset the DTD object on its reuse.

See also:
  DTDHandler::resetDocType

Implements DTDHandler.

void HandlerBase::unparsedEntityDecl | ( | const XMLCh *const | name,
|  | const XMLCh *const | publicId,
|  | const XMLCh *const | systemId,
|  | const XMLCh *const | notationName |
| ) |  |  | `[virtual]`

Receive notification of an unparsed entity declaration.

By default, do nothing. Application writers may override this method in a subclass to keep track of the unparsed entities declared in a document.

Parameters:

  | name | The entity name.
  | publicId | The entity public identifier, or null if not available.
  | systemId | The entity system identifier.
  | notationName | The name of the associated notation.

See also:
  DTDHandler::unparsedEntityDecl

Implements DTDHandler.

The documentation for this class was generated from the following file:

- HandlerBase.hpp